// Corpus31P2.pde
// 
// Gerard Paresys
// 3 10 2014
// Processing 2.0.3
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// Si le dossier data contient 4 fichiers nommés:
//   XXX.xml  (format Praat TextGrid sauve en UTF8)
//   XXX.mp3
//   XXX_Pitch.txt
//   XXX_Intensity.txt
// le sketch les ouvre
// sinon un selecteur de fichiers s'ouvre
//
// Modifier la ligne 41 au besoin
//
// Le dossier data doit contenir aussi:
//   Georgia.ttf
//
// Touche S        Sauve l'ecran (format png)
// Touche Espace   Pause 
// Touche M        Maillage
// Touche B        Dessin base
// Touche Z        Mouvement
// Touche A        Aligne Gauche / Centre
// Touche H        Horizontal / Vertical
// Touche T        Affiche temps en bas a droite
// Touche R        Reset position dessin
// Touche D        Debut
// Molette souris  Zoom
// Clic souris dans la fenêtre d'abord  
//
// Ouvre         le fichier       XXX.xml
// Ouvre et joue le fichier Audio XXX.mp3 
// Ouvre         le fichier texte XXX_Pitch.txtt    généré par Praat
// Ouvre         le fichier texte XXX_Intensity.txt généré par Praat
//  
// Chronomètre... 
//

import ddf.minim.*;         // pour AudioPlayer

String  NomFichierXML = "maore.xml"; // les 4 fichiers "maore..." doivent etre dans le dossier data
// sinon le selecteur de fichier s'ouvre      
color   CouleurBackground = color(50, 150, 50); // 
color   CouleurShape      = color(30, 150, 30);    // 
boolean Verbose           = false;
boolean Base              = true; // false
boolean Maille            = true; // true      
boolean Mouvement         = false; // true      
boolean AlignGauche       = false;
boolean Horizontal        = true;
int     DecalHorizontal   = 0;
int     DecalVertical     = 50;

PFont  maFonte;
String NomFichierAudio     = "XXX.mp3";
String NomFichierPitch     = "XXX_Pitch.txt";
String NomFichierIntensity = "XXX_Intensity.txt";
float  FacteurX            = 32;
float  Facteur;
float  Echelle             = 1;

int Couche = 0;  //Traduction
// int Couche = 1;  //Transcription
boolean DessinCurveVertex = false; 
boolean DessinCaractere = false; 
int     Blur = 60;               // 255: normal pas de blur   0: Blur max    Essayer 100
boolean AfficheT = false;        // Chrono en bas a droite
boolean DessinPitch = false;     // 
boolean DessinIntensity = true;  // 


// number of grid points horizontal
// int xCount = 30;   //20
int xCount;  
// number of grid points vertical
// int yCount = 27; // 27 x 2 = Nombre de lignes max = Nombre de segments max
int yCount; // yCount = (NombreSegment+1)/2 +1
int offsetX = 0, offsetY = 0, clickX = 0, clickY = 0;
float rotationX = 0, rotationY = 0, targetRotationX = 0, targetRotationY = 0, clickRotationX, clickRotationY; 
// int[][] Tableau = new int[2 * xCount + 1][2 * yCount + 1];
int[][] Tableau, Tableau2;

String[] list, LignesPitch;
String[] LignesIntensity;
int IndexPitch = 0;
int IndexCaracterePitch = 0;
int IndexIntensity = 0;
int IndexCaractereIntensity = 0;
float xAvantPitch, xApresPitch, yAvantPitch, yApresPitch;
float xAvantIntensity, xApresIntensity, yAvantIntensity, yApresIntensity;
int LigneText, x;
AudioPlayer player;
Minim minim;
float temps, DureeFichier;
boolean Probleme = false, Fin = false, FichierOuvert = false;
boolean ToucheEspace = false, Pause = false, Trace = false, DebutTrace = false;
float[] LignePitch, LigneIntensity;
float TempsPause = 0, TempsDebutPause = 0;
XML xml1, kid1, kid2;
XML[] kid1Data, kidkid1Data, kidkid1intervals, kidkid1intervalsxmax;
XML[] Traduction, Transcription;
int NombreDeChild2, NombreSegment;
int IndexXML = 0, Segment;
float xmin, xmax;  // Temps en seconde
String s1, s2, Content1 = "", Content2 = "", Content = "";
char Caractere;
int ValueMouseDragged =0;
int x1, y1, z1, x2, y2, z2, zTexte;
int TailleX = 500, TailleY = 500;
int PositionX = 0, PositionY = 0; // 0 0 = centre de la fenetre
int Alea; //

float xgrid, ygrid;

PImage ImageTexture;


void setup() {
  size(800, 600, P3D); 

  // maFonte = loadFont("Helvetica-50.vlw");
  // maFonte = loadFont("Geneva-48.vlw");
  // maFonte = createFont("Georgia", 24);
  maFonte = createFont("Georgia", 18);

  // background(CouleurBackground); 

  // ImageTexture = loadImage("Granit.jpg");

  File Fichier = new File(dataPath(NomFichierXML));
  if (Fichier.exists()) Ouverture(NomFichierXML);
  else selectInput("select the XML File (format Praat textGrid):", "fileSelected");
}

void draw() {

  background(CouleurBackground);
  stroke(100);
  //  line(0, 0, width, height); // Visu centre fenetre
  //  line(0, height, width, 0);

  if (! Pause) {
    temps = millis() - TempsPause; //temps en ms
    if ((! Fin) && AfficheT) AfficheTemps(temps);
    temps = temps / 1000; // temps en sec
  }

  if (FichierOuvert) {

    if (IndexXML < (NombreSegment-1)) {
      if (temps > xmax) {                        // Passage au segment suivant
        IndexXML = IndexXML + 1;
        Content = Traduction[IndexXML].getContent();
        Content2 = Transcription[IndexXML].getContent();

        if (Verbose) println();
        if (Verbose) println("IndexXML = " + IndexXML);

        if (Content == null) IndexXML = IndexXML + 1;
        else if (Content.equals("_") == true) IndexXML = IndexXML + 1;//Elimination des caracteres _ qui separe les segments
        // else if ((temps > xmin) && ! Pause) {
        else if (! Pause) {
          Segment = Traduction[IndexXML].getInt("n"); 
          xmin = Traduction[IndexXML].getFloat("xmin");
          xmax = Traduction[IndexXML].getFloat("xmax");

          println();
          println("Segment = " + Segment + "  xmin = " + xmin + "  xmax = " + xmax);
          //          println("  xmin = " + xmin);
          //          println("  xmax = " + xmax);

          IndexCaracterePitch = 0;
          IndexCaractereIntensity = 0;
          // xApresPitch = 10;
          // xApresPitch = 0;
          // IndexXML = IndexXML + 1;

          Content1 = trim(Content);
          Content2 = trim(Content2);

          //          noStroke(); // pas de contour
          //          fill(0); // Rect noir
          //          rect(0, YIntensity(40), width, 100);
          //          textFont(maFonte, 20);
          //          fill(255, 255, 0); // Texte jaune
          //          text(Content2, 10, YIntensity(40) + 5, width-20, 50 ); // Transcription
          //          fill(120, 120, 255); // Texte bleu
          //          text(Content1, 10, YIntensity(40) + 55, width-20, 50 ); // Traduction
          //          DebutTrace = true;
          println(Content2);
          println(Content1);
        }
      }
    }

    lights();
    // directionalLight(255, 0, 0, 1, 1, 0);
    // noLights();
    // background(0);
    // background(255, 0, 0); //Rouge
    // background(CouleurBackground); 

    // noStroke(); // pas de contour
    // stroke(0);
    // fill(0); // Rect noir
    // rect(0, YIntensity(40), width, 100);
    // textFont(maFonte, 20);
    textFont(maFonte);
    //fill(255, 255, 0); // Texte jaune

      // fill(0, 0, 0); // Texte noir
    // text(Content2, 10, YIntensity(40) + 5, width-20, 50 ); // Transcription
    // trim pour supprimer des carriage return dans le .xml

    fill(255, 0, 0); // Texte rouge
    text(Content1, 10, YIntensity(40) + 55, width-20, 50 ); // Traduction

    if (true) {
      //      fill(255, 255, 255); 
      //      image(ImageTexture, 0, 0);

      setView();
      for (int y = -yCount; y < yCount; y++) {
        // for (int y = -yCount; y < n-yCount; y++) {
        //        beginShape(QUAD_STRIP);
        beginShape(TRIANGLE_STRIP);
        fill(CouleurShape);
        // fill(255, 255, 255);
        // texture(ImageTexture);
        if (Maille) {
          stroke(100, 100, 100, 30);     // Couleur des lignes 0=noir 255=blanc
          strokeWeight(1); // Epaisseur des lignes
        }
        else noStroke();
        // noFill();
        // Alea = int(random(5));
        // for (int x = - xCount; x <= xCount; x++) {
        for (int x = - xCount + 1; x < xCount; x++) {
          if (y > -yCount) {
            z1 = Tableau[x + xCount][y - 1 + yCount];
            z2 = Tableau[x + xCount][y     + yCount];
            // if ((z1 > Tableau2[x + xCount][y - 1 + yCount]) || (z2 > Tableau2[x + xCount][y + yCount])) {
            if ((Tableau[x + xCount + 1][y - 1 + yCount] > Tableau2[x + xCount + 1][y - 1 + yCount]) || 
              (Tableau[x + xCount + 1][y + yCount] > Tableau2[x + xCount + 1][y + yCount]) || 
              (Tableau[x + xCount - 1][y - 1 + yCount] > Tableau2[x + xCount - 1][y - 1 + yCount]) ||
              (Tableau[x + xCount - 1][y + yCount] > Tableau2[x + xCount - 1][y + yCount]) || !Base) {
              // if ((x + xCount + 1) == Segment) zTexte = z2;
              if (Mouvement) x1 = int(TailleX / (2 * xCount) * x * zTexte / 100)     + PositionX;
              else x1 = int(TailleX / (2 * xCount) * x)     + PositionX ;
              // x1 = int(TailleX / (2 * xCount) * x)     + PositionX ;   OUI
              // x1 = int(TailleX / (2 * xCount) * x * x * x / 1000)     + PositionX ; 

              y1 = int(TailleY / (2 * yCount) * (y-1)) + PositionY ; 
              y2 = int(TailleY / (2 * yCount) * (y))   + PositionY ; 
              if (Horizontal) {
                vertex(x1, y1, z1);
                vertex(x1, y2, z2);
                //              vertex(x1, y1, z1, random(100), random(100));
                //              vertex(x1, y2, z2, random(100), random(100));
                //              vertex(x1, y1, z1, 0, 50);
                //              vertex(x1, y2, z2, 50, 0);
              }
              else {
                vertex(y1, x1, z1);
                vertex(y2, x1, z2);
              }
            }
          }
        }
        endShape();
      }
      fill(0, 0, 0); // Texte noir
      // text(Content2, 10, YIntensity(40) + 5, width-20, 50 ); // Transcription
      // text(Content2, -250, YIntensity(270) + 5 , 80); // Transcription
      // text(Content2, 0, 0, 0); // Transcription
      textAlign(CENTER);

      // text(Content2, -250, n * 30 - 200, 80); // Transcription
      y1 = int(TailleY / (2 * yCount) * (Segment-yCount)) + PositionY;
      // z2 = Tableau[x + xCount][Segment    + yCount];
      // text(Content2,0, y1, 80); // Transcription
      text(Content2, PositionX, y1, zTexte + 0); // Transcription
    }
    // println("xgrid = " + xgrid);
    // println("ygrid = " + ygrid);


    // Dans cette version l'axe horizontal de la ligne de pitch =Duree du segment
    // et le dessin est fait avec:  beginShape();  vertex(x, y);  ou curvevertex(x, y); endShape(); au choix

    if (DessinPitch) {
      if (IndexPitch < LignesPitch.length) {
        LignePitch = float(split(LignesPitch[IndexPitch], "   "));
        if (Float.isNaN(LignePitch[0])) IndexPitch = IndexPitch + 1;
        if ((temps > LignePitch[0]) && ! Pause) {
          if (Float.isNaN(LignePitch[1])) IndexPitch = IndexPitch + 1;
          else {
            if (Trace) {
              if (IndexCaracterePitch < Content1.length()) {
                textFont(maFonte, 14);
                Caractere = Content1.charAt(IndexCaracterePitch);
                xApresPitch = int(((LignePitch[0] - xmin) / (xmax - xmin)) * float(width));
                // yApresPitch = YPitch(LignePitch[1]) ;
                yApresPitch = YPitch(LignePitch[1] + 120) ;
                println("LignePitch[0] = " + LignePitch[0] + "      xApresPitch = " + xApresPitch + "    yApresPitch = " + yApresPitch );
                if (DebutTrace) {
                  println("Debuttrace n = " + Segment);
                  beginShape(); // 
                  if (DessinCurveVertex) curveVertex(xApresPitch, yApresPitch);
                  else vertex(xApresPitch, yApresPitch, 0);
                  xAvantPitch = xApresPitch;    
                  yAvantPitch = yApresPitch;
                  DebutTrace = false;
                }

                if (DessinCurveVertex) curveVertex(xApresPitch, yApresPitch);
                else vertex(xApresPitch, yApresPitch, 0);

                smooth();
                stroke(150);      // Couleur des lignes  0=noir 255=blanc
                strokeWeight(1); // Epaisseur des lignes
                noFill();
                line(xAvantPitch, yAvantPitch, xApresPitch, yApresPitch);

                if (DessinCaractere) {
                  fill(0, 0, 0); // Texte noir
                  translate(xApresPitch, yApresPitch);
                  rotate(atan2((yApresPitch - yAvantPitch), textWidth(Caractere)));
                  text(Caractere, 0, 0);
                  rotate(atan2(-(yApresPitch - yAvantPitch), textWidth(Caractere)));
                } 
                xAvantPitch = xApresPitch;    
                yAvantPitch = yApresPitch;
                IndexCaracterePitch = IndexCaracterePitch +1;
              }
            }
            Trace = true;
            IndexPitch = IndexPitch + 1;
          }
        }
      } 
      else Fin = true;
    }

    // if (DessinIntensity) {
    if (false) {
      if (IndexIntensity < LignesIntensity.length) {
        LigneIntensity = float(split(LignesIntensity[IndexIntensity], "   "));
        if (Float.isNaN(LigneIntensity[0])) IndexIntensity = IndexIntensity + 1;
        if ((temps > LigneIntensity[0]) && ! Pause) {
          if (Float.isNaN(LigneIntensity[1])) IndexIntensity = IndexIntensity + 1;
          else {
            // if (Trace) {
            xApresIntensity = int(((LigneIntensity[0] - xmin) / (xmax - xmin)) * float(xCount * 2));
            if ((xApresIntensity < (2 * xCount + 1)) && (xApresIntensity > 0) && (Segment < (2 * yCount + 1))) {
              //                  Tableau[int(xApresIntensity)][n] = int(yApresIntensity);     
              //                  Tableau[int(xApresIntensity)][n] = int(LigneIntensity[1]);     
              Tableau[int(xApresIntensity)][Segment] = int((LigneIntensity[1] - 30)*2.0);     
              // Tableau[int(xApresIntensity)][n] = n;
              println("Tableau[int(xApresIntensity)][Segment] = " + Tableau[int(xApresIntensity)][Segment]);
            }
            // println("xApresIntensity = " + xApresIntensity + "      n = " + n + "    LigneIntensity[1] = " + LigneIntensity[1] );

            Trace = true;
            // IndexIntensity = IndexIntensity + 5;
            IndexIntensity = IndexIntensity + 3;
          }
        }
      } 
      else Fin = true;
    }

    if (DessinIntensity) {
      // La derniere ligne du fichier XXX_Intensity.txt
      // LigneIntensity = float(split(LignesIntensity[LignesIntensity.length - 1], "   "));
      // float[] Fff = float(split(LignesIntensity[LignesIntensity.length - 1], "   "));
      //println("Fff[0] = " + Fff[0] + "     Fff[1] = " + Fff[1]);
      // xApresIntensity = int(((temps - xmin) / (xmax - xmin)) * float(xCount * 2));

      if (AlignGauche) xApresIntensity = int(((temps - xmin) / (12)) * float(xCount * 2));
      else xApresIntensity = int(((temps - xmin - (xmax-xmin)/2) / (12)) * float(xCount * 2)) + 30;

      //println("xApresIntensity = " + xApresIntensity);
      // noiseDetail(4, 0.001);
      if ((xApresIntensity < (2 * xCount + 1)) && (xApresIntensity > 0) && (Segment < (2 * yCount + 1))) {
        // int Facteur = int(temps * 100.0);
        // int Facteur = int(temps * Fff[0] / Fff[1]);
        // int Facteur = int(temps * LignesIntensity.length / Fff[0]);
        int Ligne = int(temps * Facteur);
        if (Verbose) println("Facteur = " + Facteur);
        if (Verbose) println("Ligne = " + Ligne);
        if (Ligne < LignesIntensity.length) {
          LigneIntensity = float(split(LignesIntensity[Ligne], "   "));
          // Tableau[int(xApresIntensity)][n] = int((LigneIntensity[1] - 30.0) * 2.0);     
          // Tableau[int(xApresIntensity)][n] = int((LigneIntensity[1] - 20.0) * 2.0);     
          // Tableau[int(xApresIntensity)][n] = Tableau2[int(xApresIntensity)][n] + int((LigneIntensity[1] - 20.0) * 2.0);     
          Tableau[int(xApresIntensity)][Segment] = Tableau2[int(xApresIntensity)][Segment] + int((LigneIntensity[1] - 20.0) * 1.0);
          // Tableau[int(xApresIntensity)][Segment] = Tableau2[int(xApresIntensity)][Segment] + int(100 * noise(xApresIntensity, Segment));
          zTexte = Tableau[int(xApresIntensity)][Segment];
          if (Verbose) println("Tableau[" + int(xApresIntensity) + "][" + Segment + "] = " + Tableau[int(xApresIntensity)][Segment]);
        }
      }
    }
  }
}

float YPitch(float w) { // w en Hz  YPitch en pixel
  return ((500 - w) / 2) + 100;
  //return ((500 - w) / 2) + 10;
}

float YIntensity(float w) {
  if (w < 40) w= 40;
  return ((100 - w) * 3) + 312;
}

void AfficheTemps(float T) {
  // T = T / 1000;
  T = int(T / 100);
  T = T / 10;
  x = width - 72;
  //  fill(0);
  //  rect(x - 3, 587, 100, 15);
  fill(0);
  textFont(maFonte, 12);
  text(T + " sec", x, height - 3);
}


void EffaceEcran() {
  PImage CopiEcran;

  // background(255); // Fond blanc

  noStroke(); // pas de contour

  // CopiEcran = get(0, int(YPitch(500)), width, int(YPitch(0)));
  CopiEcran = get(0, int(YPitch(500)) + 1, width, int(YPitch(0)));
  image(CopiEcran, 0, YPitch(500)+30);


  fill(0, Blur); // 0=noir 255=blanc
  // rect(0, YPitch(500), width, YIntensity(40) - YPitch(500));
  rect(0, 0, width, YIntensity(40) - YPitch(500));

  // textFont(maFonte, 16);
  //text("Fichier: " + NomFichierPitch + "     ("+ LignesPitch.length + " LignesPitch)", 5, 10);



  textFont(maFonte, 12);
  stroke(0, 0, 0); // Ligne noire

  //  fill(0, 0, 0); // Texte noir
  //  line(0, YPitch(75), width, YPitch(75));
  //  text("75Hz", width - 40, YPitch(75) - 10);
  //  line(0, YPitch(500), width, YPitch(500));
  //  text("500Hz", width - 40, YPitch(500) + 2);

  // text("Pause : Espace", width - 85, 575);

  //  fill(255, 0, 0); // Texte rouge
  //  stroke(255, 0, 0); // Ligne rouge
  //  text("100dB", width - 40, YPitch(75) + 2);
  //  text("40dB", width - 40, YIntensity(40) - 10);
  //  line(0, YIntensity(40), width, YIntensity(40));

  // line(0, YIntensity(40), width, YIntensity(100));

  xAvantPitch = 0;
  yAvantPitch = YPitch(75) ;
  xAvantIntensity = 0;
  yAvantIntensity = YIntensity(40) ;
}


void Debut() {
  IndexPitch = 0;
  IndexIntensity = 0;
  IndexXML = -1;
  EffaceEcran();
  EffaceTableau();
  xmax = 0;
  TempsPause = millis();
  PlayerAudioDebut();
}


void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(NomFichierAudio, 2048);
  player.play();
}


void keyPressed() {
  // println("key = " + key);
  if (key == ' ') {         // barre d'espace
    ToucheEspace = ! ToucheEspace;
    Pause = ToucheEspace;
    if (Pause) {
      player.pause();
      TempsDebutPause = millis();
    }
    else {
      player.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else  if ( key == 'p' || key == 'P' ) {
    Couche = 0; // P Phonème
    Debut();
  }
  else if (key == 'y' || key == 'Y') {
    Couche = 1; // Y Syllabe
    Debut();
  }
  else if (key == 'b' || key == 'B') Base = !Base;               // Touche B        Dessin base
  else if (key == 'm' || key == 'M') Maille = !Maille;           // Touche M        Maillage
  else if (key == 'z' || key == 'Z') Mouvement = !Mouvement;     // Touche Z        Mouvement
  else if (key == 'a' || key == 'A') AlignGauche = !AlignGauche; // Touche A        Aligne Gauche / Centre
  else if (key == 'h' || key == 'H') Horizontal = !Horizontal;   // Touche H        Horizontal / Vertical
  else if (key == 'r' || key == 'R') {                           // Touche R        Reset position dessin
    rotationY = 0; // Touche R        Reset position
    rotationX = 0; 
    Echelle   = 1;
    rotateX(-rotationY); 
    rotateY(rotationX);
    scale(Echelle);
  }
  else if (key == 'o' || key == 'O') {
    Couche = 4; // O Orthographique
    Debut();
  }
  else if (key == 's' || key == 'S') saveFrame("Screen" + frameCount + ".png");
  else if (key == 't' || key == 'T') AfficheT = !AfficheT;     // Touche T        Affiche temps en bas a droite
  else if (key == 'd' || key == 'D') Debut();                  // Touche D        Debut
  else if (keyPressed && (key == CODED)) { // If it's a coded key
    if (keyCode == LEFT) {            // Left arrow
      FacteurX = FacteurX / 2;
      Debut();
    } 
    else if (keyCode == RIGHT) {      // Right arrow
      FacteurX = FacteurX * 2;
      Debut();
    }
  }

  {
    // println("key = " + key  + "  Erreur taper Espace");
  }
}


void fileSelected(File FichierChoisi) {
  if (FichierChoisi == null) {
    println("Pas de fichier XXX.xml ouvert!");
    exit();
  } 
  else Ouverture(FichierChoisi.getAbsolutePath());
}

void Ouverture(String NomFichier) {
  // println("NomFichierXML = " + NomFichier);
  Probleme = false;

  File Fichier = new File(dataPath(NomFichier));
  if (!Fichier.exists()) { 
    println("Le fichier " + NomFichier + " n'existe pas");
    Probleme = true;
  }

  if (!Probleme) {
    list = split(NomFichier, '.');
    NomFichierXML = list[0] + ".xml";
    if (loadStrings(NomFichierXML) == null) { 
      println("Le fichier " + NomFichierXML + " n'existe pas");
      Probleme = true;
    }
  }

  if (!Probleme) {
    // xml1 = new XMLElement(this, NomFichierXML);
    xml1 = loadXML(NomFichierXML);  //Processing 2.0
    println("Ouverture de: " + NomFichierXML);
    if (Verbose) println("1-----------------------------------------------------------");
    // NombreDeChild1 = xml1.getChildCount();
    if (xml1.hasChildren()) { 
      //  println("xml1.hasChildren");
      if (Verbose) println("xml1.listChildren() : ");
      if (Verbose) println(xml1.listChildren());
    } 
    else {
      println("Le fichier xml n'a pas le bon format");      
      Probleme = true;
    }
  }

  if (!Probleme) {
    if (!(xml1.listChildren()[1] == "items" )) {
      println("Le fichier xml n'a pas le bon format");
      Probleme = true;
    }
  }

  if (!Probleme) {
    kid1Data = xml1.getChildren("items");
    //    println("2-----------------------------------------------------------");
    //    println(kid1Data);
    kidkid1Data = kid1Data[0].getChildren("item");
    //      s2 = kidkid1Data[1].getName();
    //      println("s2 = " + s2);
    if (Verbose) println("kidkid1Data-----------------------------------------------------------");
    // println(kidkid1Data);  // gros a lister
    if (Verbose) println("-----------------------------------------------------------");
    if (Verbose) println("Length of kidkid1Data = " + kidkid1Data.length);
    if (Verbose) println("kidkid1Data[0].getName() = " + kidkid1Data[0].getName());
    if (Verbose) println("kidkid1Data[1].getName() = " + kidkid1Data[1].getName());
    if (Verbose) println("kidkid1Data[0].listAttributes() = " + kidkid1Data[1].getChildren("item"));

    //    kidkid1intervals = kidkid1Data[4].getChildren("intervals");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println(kidkid1intervals);
    //    println("-----------------------------------------------------------");
    //    println("Length of kidkid1intervals = " + kidkid1intervals.length);
    //    println("kidkid1intervals[10].getName() = " + kidkid1intervals[10].getName());
    //    println("kidkid1intervals[11].getName() = " + kidkid1intervals[11].getName());
    //    println("kidkid1intervals.listAttributes() = " + kidkid1intervals[10].getChildren("intervals"));
    //
    //    // kidkid1intervalsxmax = kidkid1intervals[76].getChildren("xmax");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println("kidkid1intervals[26].getInt(\"n\")      = " + kidkid1intervals[26].getInt("n"));
    //    println("kidkid1intervals[26].getFloat(\"xmax\") = " + kidkid1intervals[26].getFloat("xmax"));
    //    println("kidkid1intervals[26].getFloat(\"xmin\") = " + kidkid1intervals[26].getFloat("xmin"));
    //    println("kidkid1intervals[26].getContent()     = " + kidkid1intervals[26].getContent());
    //    println();
    //    println("kidkid1intervals[27].getFloat(\"xmax\") = " + kidkid1intervals[27].getFloat("xmax"));
    //    println("-----------------------------------------------------------");
    //      println("Length of kidkid1intervalsxmax = " + kidkid1intervalsxmax.length);
    //      println("kidkid1intervalsxmax[10].getName() = " + kidkid1intervalsxmax[10].getName());
    //      println("kidkid1intervalsxmax[11].getName() = " + kidkid1intervalsxmax[11].getName());
    //      println("kidkid1intervalsxmax.listAttributes() = " + kidkid1intervalsxmax[10].getChildren("intervals"));
    //    fill(0);
    //    textFont(maFonte, 16);
    //    fill(180);
    //    textFont(maFonte, 12);
    //    text(NomFichierXML, 10, 65);

    Traduction = kidkid1Data[0].getChildren("intervals");
    NombreSegment = Traduction.length;
    if (Verbose) println("oooooooooooooooooooooooooooooooooooooooooooooo");
    // println(Traduction);  // gros a lister
    if (Verbose) println("oooooooooooooooooooooooooooooooooooooooooooooo");

    Transcription = kidkid1Data[1].getChildren("intervals");
    if (NombreSegment != Transcription.length ) {
      println("Le fichier xml n'a pas le bon format");
      println("il n'y a pas le meme nombre de segment transcrit et traduit");
      Probleme = true;
    }
  } 

  if (! Probleme) { 
    NomFichierPitch = list[0] + "_Pitch.txt";
    if (loadStrings(NomFichierPitch) == null) { 
      println("Le fichier " + NomFichierPitch + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesPitch = loadStrings(NomFichierPitch);
      println("Ouverture de: " + NomFichierPitch +"  " + LignesPitch.length + " lignes" );
    }
  } 

  if (! Probleme) { 
    NomFichierIntensity = list[0] + "_Intensity.txt";
    if (loadStrings(NomFichierIntensity) == null) { 
      println("Le fichier " + NomFichierIntensity + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesIntensity = loadStrings(NomFichierIntensity);
      println("Ouverture de: " + NomFichierIntensity +"  " + LignesIntensity.length + " lignes" );
    }
  } 

  if (! Probleme) { 
    NomFichierAudio = list[0] + ".mp3";
    if (loadStrings(NomFichierAudio) == null) { 
      println("Le fichier " + NomFichierAudio + " n'existe pas");
      Probleme = true;
    } 
    else println("Ouverture de: " + NomFichierAudio);
  }

  if (! Probleme) { 
    println("NombreSegment = " + NombreSegment); 
    minim = new Minim(this);
    player = minim.loadFile(NomFichierAudio, 2048);

    LignePitch = float(split(LignesPitch[LignesPitch.length - 1 ], "   "));
    DureeFichier = LignePitch[0];
    if (Verbose) println("Duree " + NomFichierPitch + " = " + DureeFichier + " sec");

    LigneIntensity = float(split(LignesIntensity[LignesIntensity.length - 1 ], "   "));
    DureeFichier = LigneIntensity[0];
    if (Verbose) println("Duree " + NomFichierIntensity + " = " + DureeFichier + " sec");

    // float[] Fff = float(split(LignesIntensity[LignesIntensity.length - 1], "   "));
    // int Facteur = int(temps * LignesIntensity.length / Fff[0]);
    Facteur = LignesIntensity.length / LigneIntensity[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 

    player.play();
    TempsPause = millis();
    FichierOuvert = true;
    xmax = 0;
    IndexXML = -1;

    yCount = (NombreSegment+1)/2 +1;
    xCount = 30;

    // int[][] Tableau = new int[2 * xCount + 1][2 * yCount + 1];
    Tableau = new int[2 * xCount + 1][2 * yCount + 1];
    Tableau2 = new int[2 * xCount + 1][2 * yCount + 1];
    // int[][] Tableau;
    EffaceTableau();

    println("xCount = " + xCount);
    println("yCount = " + yCount);
  }
  else {
    exit();
  }
}


void mousePressed() {
  clickX = mouseX;
  clickY = mouseY;
  clickRotationX = rotationX;
  clickRotationY = rotationY;
}

void setView() {
  translate(width*0.5, height*0.5);

  if (mousePressed) {
    // if (mouseDragged()) {
    offsetX = mouseX-clickX;
    offsetY = mouseY-clickY;
    targetRotationX = clickRotationX + offsetX/float(width) * TWO_PI;
    // targetRotationY = min(max(clickRotationY + offsetY/float(height) * TWO_PI, -HALF_PI), HALF_PI);
    targetRotationY = clickRotationY + offsetY/float(height) * TWO_PI;
    rotationX += (targetRotationX-rotationX)*0.25; 
    rotationY += (targetRotationY-rotationY)*0.25;
  }
  rotateX(-rotationY); 
  rotateY(rotationX);
  scale(Echelle);
}

void mouseWheel(MouseEvent event) {
  float e = event.getCount();
  Echelle = Echelle * pow( 2, e/10) ;
  println("Echelle = " + Echelle);
}

void EffaceTableau() {
  for (int y = -yCount; y < yCount; y++) {
    for (int x = - xCount; x <= xCount; x++) {
      // Tableau[x + xCount][y + yCount] = 0;
      // Tableau[x + xCount][y + yCount] = -abs(int(3 * x ));

      // Tableau[x + xCount][y + yCount] = int(2 * sqrt((xCount * xCount) - (x * x * 0.95)));
      // Tableau2[x + xCount][y + yCount] = int(2 * sqrt((xCount * xCount) - (x * x * 0.95)));

      Tableau[x + xCount][y + yCount] = int(50 * (cos(radians(x*5))+1));
      Tableau2[x + xCount][y + yCount] = int(50 * (cos(radians(x*5))+1));
      //  Tableau[x + xCount][y + yCount] = 0;
      //  Tableau2[x + xCount][y + yCount] = 0;

      //      if ((x > -xCount / 2) && (x < xCount / 2)) {
      //        Tableau[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x * x)));
      //        Tableau2[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x * x)));
      //      }
      //      if ((x > xCount / 2)) {
      //        Tableau[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x - xCount / 2) * (x - xCount / 2)));
      //        Tableau2[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x - xCount / 2) * (x - xCount / 2)));
      //      }
    }
  }
  // Tableau[xCount][yCount] = 10;
  // Tableau[10][10] = 10;
}

void stop() {
  // always close Minim audio classes when you are done with them
  player.close();
  minim.stop();
  super.stop();
}

